/*
 * Copyright (C) 2003 Jelmer Vernooij <jelmer@samba.org>
 */

#include "kregedit.h"
#include <kapplication.h>
#include <dcopclient.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char *description =
    I18N_NOOP("Simple KDE Application for viewing and editing the windows registry");

static const char *version = "0.1";

static KCmdLineOptions options[] =
{
    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    { 0, 0, 0 }
};

int main(int argc, char **argv)
{
    KAboutData about("kregedit", I18N_NOOP("kregedit"), version, description,
                     KAboutData::License_GPL, "(C) 2003 Jelmer Vernooij", 0, 0, "jelmer@samba.org");
    about.addAuthor( "Jelmer Vernooij", "KDE interface", "jelmer@samba.org", "http://samba.org/~jelmer/" );
    about.addAuthor( "Richard Sharpe", "Low-Level registry functions", "rsharpe@samba.org", "http://www.richardsharpe.com/" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions(options);
    KApplication app;

    // register ourselves as a dcop client
    app.dcopClient()->registerAs(app.name(), false);

    // see if we are starting with session management
    if (app.isRestored())
    {
        RESTORE(kregedit);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
        if (args->count() == 0)
        {
            kregedit *widget = new kregedit;
            widget->show();
        }
        else
        {
            int i = 0;
            for (; i < args->count(); i++)
            {
                kregedit *widget = new kregedit;
                widget->show();
                widget->load(args->url(i));
            }
        }
        args->clear();
    }

    return app.exec();
}
